-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 11-Desember-2014
-- Description:	Insert Data to TB_T_DLV_FI_JOURNAL
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_DVL_FI_JOURNAL_GR]
	@PROCESS_ID BIGINT,
	@DOC_NO VARCHAR(15),
	@DOC_YEAR VARCHAR(4),
	@CONDITION_TYPE VARCHAR(5),
	@DC_INDICATOR VARCHAR(1),
	@GL_ACCOUNT VARCHAR(10),
	@LOCAL_CURR VARCHAR(3),
	@DOC_TYPE VARCHAR(2),
	@ITEM_TEXT VARCHAR(50),
	@EXCHANGE_RATE DECIMAL,
	@DELIVERY_NOTE_NO VARCHAR(50),
	@DOC_ITEM VARCHAR(5),
	@TRANSACTION_CD VARCHAR(3)
AS
DECLARE
	@QTY INT,
	@AMT_DOC NUMERIC(18, 0),
	@USERID VARCHAR(20),
	@CREATED_DT VARCHAR(20)
BEGIN
	SELECT TOP 1 @USERID = CONVERT(VARCHAR(20), UPDATE_BY) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO
	SELECT TOP 1 @CREATED_DT = MAX(UPDATE_DT) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO

	IF(@DOC_ITEM = '1')
	BEGIN
		SET @QTY = 0
		INSERT INTO TB_T_DLV_FI_JOURNAL 
		SELECT DISTINCT @DOC_NO AS DOC_NO, 
			   @DOC_YEAR AS DOC_YEAR,
			   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY DELIVERY_NOTE_NO),
			   CASE WHEN(@CREATED_DT = '') THEN GETDATE() ELSE @CREATED_DT END AS DOC_DT, 
			   @TRANSACTION_CD AS TRANSACTION_CD, 
			   @CONDITION_TYPE AS CONDITION_TYPE, 
			   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
			   @GL_ACCOUNT AS GL_ACCOUNT,
			   NULL AS ROUTE_CD, 
			   CONVERT(DECIMAL, [dbo].[fn_PROTO_GET_DOC_QTY](DELIVERY_NOTE_NO, @PROCESS_ID)) AS QTY, 
			   [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID) AS AMT_DOC, 
			   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
			   (CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID)) * @EXCHANGE_RATE) AS AMT_LOCAL,
			   @LOCAL_CURR AS LOCAL_CURR,
			   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS PO_NO,
			   NULL AS TAX_CD,
			   @EXCHANGE_RATE AS EXCHANGE_RATE,
			   NULL AS COST_CENTER_CD,
			   @DOC_TYPE AS DOC_TYPE,
			   NULL AS GL_BALANCE_FLAG,
			   MAX(BUDGET_NO) AS WBS_NO,
			   'PC' AS UOM,
			   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS ITEM_TEXT,
			   @USERID AS CREATED_BY,
			   @CREATED_DT AS CREATED_DT,
			   NULL AS CHANGED_BY,
			   NULL AS CHANGED_DT,
			   @PROCESS_ID AS PROCESS_ID
		FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO 
		--GROUP BY DELIVERY_NOTE_NO, UPDATE_DT, CURR_CD ORDER BY PO_NO
		GROUP BY DELIVERY_NOTE_NO, CURR_CD ORDER BY PO_NO
	END
	ELSE
	BEGIN
		SELECT @QTY = SUM(CONVERT(DECIMAL, ORDER_QTY)) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO 
		SELECT @AMT_DOC = SUM(CONVERT(NUMERIC(18, 0), PO_AMOUNT)) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO
		
		INSERT INTO TB_T_DLV_FI_JOURNAL 
		SELECT DISTINCT @DOC_NO AS DOC_NO, 
			   @DOC_YEAR AS DOC_YEAR, 
			   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY DELIVERY_NOTE_NO), 
			   CASE WHEN(@CREATED_DT = '') THEN GETDATE() ELSE @CREATED_DT END AS DOC_DT, 
			   @TRANSACTION_CD AS TRANSACTION_CD, 
			   @CONDITION_TYPE AS CONDITION_TYPE, 
			   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
			   @GL_ACCOUNT AS GL_ACCOUNT,
			   NULL AS ROUTE_CD, 
			   (CONVERT(DECIMAL, [dbo].[fn_PROTO_GET_DOC_QTY](DELIVERY_NOTE_NO, @PROCESS_ID)) * (-1)) AS QTY, 
			   (CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID)) * (-1)) AS AMT_DOC, 
			   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
			   ((CONVERT(NUMERIC(15, 3), [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID)) * @EXCHANGE_RATE) * (-1)) AS AMT_LOCAL,
			   @LOCAL_CURR AS LOCAL_CURR,
			   CONVERT(VARCHAR(11), [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID)) AS PO_NO,
			   NULL AS TAX_CD,
			   @EXCHANGE_RATE AS EXCHANGE_RATE,
			   NULL AS COST_CENTER_CD,
			   @DOC_TYPE AS DOC_TYPE,
			   NULL AS GL_BALANCE_FLAG,
			   MAX(BUDGET_NO) AS WBS_NO,
			   'PC' AS UOM,
			   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS ITEM_TEXT,
			   @USERID AS CREATED_BY,
			   @CREATED_DT AS CREATED_DT,
			   NULL AS CHANGED_BY,
			   NULL AS CHANGED_DT,
			   @PROCESS_ID AS PROCESS_ID
		FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO 
		--GROUP BY DELIVERY_NOTE_NO, UPDATE_DT, CURR_CD ORDER BY PO_NO
		GROUP BY DELIVERY_NOTE_NO, CURR_CD ORDER BY PO_NO
	END	
END

